#include "DxLib.h"
#include "Map.h"
#include "Player.h"
#include "Monster.h"

// O[oϐ>_<
int gSeq = 0;				// ʃ[h
int count = 0;

// OtBbNnh
int gPacman[50];			// pbN}
int gMapChip[20];			// }bv`bv
int gMonster;				// 񂷂[
int gBg;					// wi
int ghTitle;				// ^Cg
int ghStart;				// X^[g
int ghMiss;					// ~X
int ghClear;				// NA


//NX̃O[o`
Map map;
Player Pl;
Monster monster[4];

// 摜̓ǂݍ
int LoadData()
{
// 摜̓ǂݍ
	if(LoadDivGraph("pacman.png",50, 10, 5, 48, 48, gPacman)==-1) {
		MessageBox(NULL,"pacman.png","ReadError",MB_OK);
		return -1;
	}
	if(LoadDivGraph("mapchip1.png", 20, 10, 2, 16, 16, gMapChip)==-1) {
		MessageBox(NULL,"mapchip1.png","ReadError",MB_OK);
		return -1;
	}
	gMonster = LoadGraph("Monster.png");
	gBg = LoadGraph("bg1.jpg");

	ghTitle = LoadGraph("Title.png");
	ghStart = LoadGraph("Start.png");
	ghClear = LoadGraph("Clear.png");
	ghMiss = LoadGraph("Miss.png");

	return 0;
}
// Q[Ԃ̏
void GameInit()
{
	map.LoadFile("StageData.txt");		// }bvf[^̓ǂݍ

	// Q[̐ݒ
	Pl.Init(15,19,0);
//	void    Init(int px, int py, int st,int tm, int stMax, int rx, int ry);	// X^[̏
	monster[0].Init( 15,     14,      4,     0,        80,      2,      2);
	monster[1].Init( 15,     14,      4,    16,        80,      2,     27);
	monster[2].Init( 15,     14,      4,    32,        80,     28,      2);
	monster[3].Init( 15,     14,      4,    64,        80,     28,     27);

	return;
}

// 
int Init()
{
//	ChangeWindowMode(TRUE);				// EChE[hŋN
										//	SʋN(Rgɂ)̂ق쑬x͈肷
										// AbZ[W{bNX\Ȃ

//	SetUse3DFlag(FALSE);				// Rc֐FgpȂ
//	SetWaitVSyncFlag(FALSE);			// vsync҂̐ݒ

	if(DxLib_Init() == -1) return -1;

	SetDrawScreen( DX_SCREEN_BACK);		// ʂɏ݂܂錾
	SetTransColor(0,0,255);				// ߐFw͉摜[h̑OɁI

	if(LoadData()==-1) {				// 摜̃[hAsƂDxLibłĂ̂
		DxLib_End();					// ƏIĂ
		return -1;
	}

	GameInit();
	return 0;
}

// }bvzuit[`j
int MapSet()
{
	int sx,sy,st;
	int dot = 0;
	
	DrawGraph(0,0,gBg,FALSE);
	for(sy=0;sy<30;sy++){				// }bv̑傫[32,30]̃}WbNio[CȊ
		for(sx=0;sx<32;sx++){
			st = map.Get(sx,sy);
			DrawGraph(sx*16,sy*16,gMapChip[st],TRUE);
			if(st == 1 || st == 2) dot++; 
		}
	}
	if( dot == 0 ){		// ĤׂcĂȂ
		return 5;		// NAłA炢˂撣˂
	}
	return 0;
}

// pNjړ֐
int PakuoMove()
{
	int keyIn = 0;				// ͔p
	int key = GetJoypadInputState( DX_INPUT_KEY_PAD1 );

	if(key & PAD_INPUT_START) return -1;				// PAD_INPUT_START  [ESC]Key

	if(key & PAD_INPUT_UP) keyIn += INPUT_UP;			// L[̓tO̐ݒ
	if(key & PAD_INPUT_DOWN) keyIn += INPUT_DOWN;		// PAD_INPUT_`̐錾DxLibȂ̂ŁA̕PlayerNX̊Oɏo
	if(key & PAD_INPUT_LEFT) keyIn += INPUT_LEFT;
	if(key & PAD_INPUT_RIGHT) keyIn += INPUT_RIGHT;

	Pl.SetKey(keyIn);
	Pl.Move(map);			// pNjNXDxLibƂ̎؂藣
							// XAWin32APIDirectXɐi߂邱Ɨ\肵Ă̂ŁAPlayerNXɂDxLibˑȂ

	return 0;
}

void wait_fanc(){
    int term;
    static int t=0;
    term = GetNowCount()-t;
    if(31-term>0)
            Sleep(31-term);
    t=GetNowCount();
    return;
}

// FPS\
void fps(){
    int i;
    static int t=0,ave=0,f[60];

    f[count%60]=GetNowCount()-t;
    t=GetNowCount();
    if(count%60==59){
        ave=0;
        for(i=0;i<60;i++)
            ave+=f[i];
        ave/=60;
    }
    if(ave!=0){
        DrawFormatString(512,448,GetColor(255,255,255),"%.1fFPS",1000.0/(double)ave);
        DrawFormatString(512,464,GetColor(255,255,255),"%dms"  ,ave);
    }
    return;
}
int MonsterMove()
{
	int result = 0;
	int i;
	for(i=0;i<=3;i++){
		if(monster[i].Valid == 0) continue;
		result += monster[i].Move(map, Pl.px,Pl.py);
	}
//	if(result) MessageBox(NULL,"EE܁EEII","Miss",MB_OK);
	return result;
}

// Q[ʂ̕`iDxLibˑj
int DrawGame()
{
	int i;
	int result = 0;
	// }bviwij̕`
	if(MapSet())result = 4;

	// pNj̕`
	DrawGraph(Pl.DrawPos_X(), Pl.DrawPos_Y(), gPacman[Pl.DrawStatus()],TRUE);

	// X^[̕`
	for(i=0;i<=3;i++){
		if(monster[i].Valid == 0) continue;
		DrawGraph(monster[i].DrawPos_X(), monster[i].DrawPos_Y(), gMonster,TRUE);
	}

	// _̕\
	DrawFormatString(512,0,RGB(255,255,255),"SCORE:");
	DrawFormatString(512,16,RGB(255,255,255),"%6d",Pl.GetScore());

	return result;
}

int GameLoop()
{
	int result = 0;
	while((ProcessMessage()==0)&&(result == 0)){
		ClearDrawScreen();				// `ʁiʁj̃NA

		if(PakuoMove())	return 0;		// pNj̈ړ
		if(MonsterMove()) result = 4;	// X^[̈ړ

		if(DrawGame()) result = 5;		// Q[ʂ̕`iDxLibj
		
		fps();
		count++;
		wait_fanc();
		ScreenFlip();				// ƕ\ւ
	}
	return result;
}
// ^Cg
int GameTitle()
{
	int key = 0;
	int result = 0;

	while(ProcessMessage()==0){
		ClearDrawScreen();		// `ʁiʁj̃NA
		DrawGraph(0,0,ghTitle,FALSE);
		key = GetJoypadInputState( DX_INPUT_KEY_PAD1 );

		if(key & PAD_INPUT_START) {		// PAD_INPUT_START  [ESC]Key
			result = 0;	// GameI
			break;
		}
		if(key & PAD_INPUT_A) {			// PAD_INPUT_B		[X]key
			result = 2;
			break;
		}
		ScreenFlip();
	}
	return result;
}
// Q[Jn
int GameStart()
{
	int key = 0;
	int result = 0;
	GameInit();				// ̃Q[

	while(ProcessMessage()==0){
		ClearDrawScreen();		// `ʁiʁj̃NA
		DrawGame();				// Q[ʂ̕`
		key = GetJoypadInputState( DX_INPUT_KEY_PAD1 );

		if(key & PAD_INPUT_START) {		// PAD_INPUT_START  [ESC]Key
			result = 0;	// GameI
			break;
		}
		if((key & PAD_INPUT_LEFT)||(key & PAD_INPUT_RIGHT)) {
			result = 3;
			break;
		}
		ScreenFlip();
	}
	return result;
}

// ꂽEEE
int MissGame()
{
	int key = 0;
	int result = 0;
	while(ProcessMessage()==0){
		ClearDrawScreen();		// `ʁiʁj̃NA
		DrawGame();				// Q[ʂ̕`
		DrawGraph(0,0,ghMiss,TRUE);
		key = GetJoypadInputState( DX_INPUT_KEY_PAD1 );
		ScreenFlip();

		if(key & PAD_INPUT_START) {		// PAD_INPUT_START  [ESC]Key
			result = 0;	// GameI
			break;
		}
		if(key & PAD_INPUT_A) {			// PAD_INPUT_A		[Z]key
			result = 1;
			break;
		}
	}
	return result;
}
// 肠
int WinGame()
{
	int key;
	int result = 0;
	while(ProcessMessage()==0){
		ClearDrawScreen();		// `ʁiʁj̃NA
		DrawGame();				// Q[ʂ̕`
		DrawGraph(0,0,ghClear,TRUE);

		key = GetJoypadInputState( DX_INPUT_KEY_PAD1 );

		if(key & PAD_INPUT_START) {		// PAD_INPUT_START  [ESC]Key
			result = 0;	// GameI
			break;
		}
		if(key & PAD_INPUT_A) {			// PAD_INPUT_A		[Z]key
			result = 1;
			break;
		}
		ScreenFlip();
	}
	return result;
}

// C[v
void MainLoop()
{
	static int gSeq = 1;
	while(gSeq != 0){
		switch(gSeq){
			case 1:
				gSeq = GameTitle();
				break;
			case 2:
				gSeq = GameStart();
				break;
			case 3:
				gSeq = GameLoop();
				break;
			case 4:
				gSeq = MissGame();
				break;
			case 5:
				gSeq = WinGame();
				break;
		}
	}
	return;
}
int WINAPI WinMain(HINSTANCE hI,HINSTANCE hP, LPSTR lpC, int nC)
{
	if(Init()) return -1;	// 

	MainLoop();				// C[`

	DxLib_End();			// Ƃ܂
	return 0;
}